
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "defines.h"
#include "main.h"


// the server port
#define SERVER_PORT 8889

// the size of the input buffer (64KBs should be enough for UDP packets)
#define INPUT_BUFFER_SIZE (64*1024)


int main(void) {

	struct sockaddr_in addrServer; // my address information
	struct sockaddr_in addrClient; // connector's address information
	unsigned char inputBuffer[INPUT_BUFFER_SIZE];
	int packetSize, sockfd;
	socklen_t addrSize;

	// create a socket
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		fprintf(stderr, "MAIN: Error creating the socket.\n");
		exit(1);
	}

	addrServer.sin_family = AF_INET;          // host byte order
	addrServer.sin_port = htons(SERVER_PORT); // short, network byte order
	addrServer.sin_addr.s_addr = INADDR_ANY;  // automatically fill with my IP

	if (bind(sockfd, (struct sockaddr *)&addrServer, sizeof(struct sockaddr)) == -1) {
		fprintf(stderr, "MAIN: Error binding the socket.\n");
		exit(1);
	}

	addrSize = sizeof(struct sockaddr);

	// the main loop
	while (1) {
		if ((packetSize = recvfrom(sockfd, inputBuffer, INPUT_BUFFER_SIZE - 1 , 0, (struct sockaddr *)&addrClient, &addrSize)) == -1) {
			fprintf(stderr, "MAIN: recvfrom() failed.\n");
			exit(1);
		}

		// parse the packet
		if (inputBuffer[0] == 'I') {
			// got an integer
			fprintf(stderr, " %d", (inputBuffer[1] << 24) | (inputBuffer[2] << 16) | (inputBuffer[3] << 8) | inputBuffer[4]);
		}
		else if (inputBuffer[0] == 'S') {
			// got a string
			inputBuffer[packetSize] = 0;
			fprintf(stderr, " %s", &inputBuffer[1]);
		}
	}

	shutdown(sockfd, 0);
	close(sockfd);

	return 0;
} 


